# -*- encoding: utf-8 -*-
#
#    This is pncconf2, a graphical configuration editor for LinuxCNC
#    Copyright 2013 Arvid Brodin
#
#    This is based on pncconf (Copyright 2009 Chris Morley),
#    in turn based on stepconf, a graphical configuration editor for
#    linuxcnc (Copyright 2007 Jeff Epler <jepler@unpythonic.net>).
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from halcomp.linuxcnc.core import HalCompPid, HalCompAxis

AXISCHAR = "xyzabcuyws"

class Axis(object):

	def __init__(self, axisno):
		self._axisno = axisno
		self._nets = {}
		self._comps = {}
		self._comps["pid"] = HalCompPid("pid." + AXISCHAR[self._axisno], self._axisno)
		self._comps["axis"] = HalCompAxis("axis.%d" % axisno)
		#self._comps["motion"] = HalCompMotion()

	def set_output(self, out_dev):
		self._comps["output"] = out_dev

	def set_feedback(self, fb_dev):
		self._comps["feedback"] = fb_dev

	def generate_hal(self, file):
		print >>file
		print >>file, "#*********************************************************"
		if self._axisno != 9:
			print >>file, "#  AXIS %s" % AXISCHAR[self._axisno].upper()
		else:
			print >>file, "#  SPINDLE"
		print >>file, "#*********************************************************"
		print >>file

		for comp in self._comps:
			if self._comps[comp].generate_hal(file) > -1:
				print >>file
			self._comps[comp].generate_nets(self._nets)

		for net in self._nets:
			if self._nets[net].generate_hal(file, AXISCHAR[self._axisno] + "-") > -1:
				print >>file
