# -*- encoding: utf-8 -*-
#
#    This is pncconf2, a graphical configuration editor for LinuxCNC
#    Copyright 2013 Arvid Brodin
#
#    This is based on pncconf (Copyright 2009 Chris Morley),
#    in turn based on stepconf, a graphical configuration editor for
#    linuxcnc (Copyright 2007 Jeff Epler <jepler@unpythonic.net>).
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from net import Net

class HalComp(object):

	def __init__(self, name):
		self._name = name

	def _net(self, nets, netname, dir, pinname):
		# nets: dictionary of nets
		# name: string; name of net excluding axis prefix
		# pin: string; name of pin
		# dir: string; pin type: "<=" out, "<=>" bidir, "=>" in
		if not netname in nets:
			nets[netname] = Net(netname)

		pinname = self._name + "." + pinname
		if dir == "<=":
			nets[netname].set_pin_out(pinname)
		elif dir == "<=>":
			nets[netname].add_pin_bidir(pinname)
		elif dir == "=>":
			nets[netname].add_pin_in(pinname)
		else:
			raise NetError("invalid direction spec")

	def generate_hal(self, file):
		if not self._params:
			return -1

		for param in self._params:
			print >>file, ("setp   " + (self._name + "." + param[0]).ljust(45) +
				" " + param[1])

		return 0

#	def generate_nets(self, nets):
#		# nets: dictionary of Net
