# -*- encoding: utf-8 -*-
#
#    This is pncconf2, a graphical configuration editor for LinuxCNC
#    Copyright 2013 Arvid Brodin
#
#    This is based on pncconf (Copyright 2009 Chris Morley),
#    in turn based on stepconf, a graphical configuration editor for
#    linuxcnc (Copyright 2007 Jeff Epler <jepler@unpythonic.net>).
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

class MesaP25(object):

	def __init__(self, name):
		self.name = name

	def display(self, parent):
		print parent + "-" + self.name


class MesaFPGA(object):

	def __init__(self, halname):
		self.halname = halname
		self.connectors = []
		self.daughters = []

	# Add daughterboard
	def add_daughter(self, db, conn):
		# FIXME: check conn is valid
		self.daughters.append([db, conn])

	def no_daughters(self):
		return len(self.daughters)

	def display_conns(self):
		for conn in self.connectors:
			conn.display(self.halname)

	def display_pins(self):
		for daughter in self.daughters:
			daughter[0].display(self.halname + ".")

	def generate_hal(self, file):
		print >>file, "setp\t" + self.halname + ".watchdog.timeout_ns 10000000"
		print >>file, "addf\t" + self.halname + ".read servo-thread"
		print >>file, "addf\t" + self.halname + ".write servo-thread"
		print >>file, "addf\t" + self.halname + ".pet_watchdog servo-thread"


class M5I25(MesaFPGA):

	def __init__(self, cardno):
		MesaFPGA.__init__(self, "hm2_5i25." + str(cardno))
		self.connectors.append(MesaP25("P3"))
		self.connectors.append(MesaP25("P2"))
