#!/usr/bin/python2
# -*- encoding: utf-8 -*-
#
#    This is pncconf2, a graphical configuration editor for LinuxCNC
#    Copyright 2013 Arvid Brodin
#
#    This is based on pncconf (Copyright 2009 Chris Morley),
#    in turn based on stepconf, a graphical configuration editor for
#    linuxcnc (Copyright 2007 Jeff Epler <jepler@unpythonic.net>).
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os
import time
from machine import Machine
from halcomp.mesa.FPGAs import M5I25
from halcomp.mesa.daughterboards import M7I76, M7I77
from axis import Axis
from halcomp.mesa.hm2 import *


# Probably move these generate_* into class machine...

def generate_mesa_init(file, machine):

	# FIXME: look at machine to figure this out
	print >>file, "loadrt hostmot2"
	print >>file, "loadrt hm2_pci config=\"num_encoders=6 num_pwmgens=0 num_3pwmgens=0 num_stepgens=0 sserial_port_0=000xxxxx\""


def generate_axes_init(file, machine):

	# FIXME: look at axes etc to figure out needed components
	print >>file, "loadrt pid names=pid.x,pid.z,pid.s"
	print >>file, "loadrt abs names=abs.spindle"
	print >>file, "loadrt lowpass names=lowpass.spindle"
	print >>file, "loadrt scale names=scale.spindle"
	print >>file


def generate_hal(machine):

#	filename = os.path.join(base, machine.name + ".hal")
	filename = machine.name + ".hal"
	file = open(filename, "w")
	print >>file, "# Generated by PNCconf2 at %s" % time.asctime()
	print >>file, "# If you make changes to this file, they will be overwritten"
	print >>file, "# when you run PNCconf again"
	print >>file
        print >>file, "loadrt trivkins"
        print >>file, "loadrt [EMCMOT]EMCMOT servo_period_nsec=[EMCMOT]SERVO_PERIOD num_joints=[TRAJ]AXES"
	print >>file
	generate_mesa_init(file, machine)
	for card in machine.cards:
		card.generate_hal(file)		# Watchdog timeout, 'addf <func> thread' etc

	generate_axes_init(file, machine)
	for axis in machine.axes:
		axis.generate_hal(file)

	# FIXME: Misc signals


def get_machine_name():

	return "pncconf-test"


def get_installed_HW(machine):

	"""
	Let the user select the installed HW:
	"""
	machine.cards.append(M5I25(len(machine.cards)))
	#machine.cards.append(EPP(0))


def get_daughtercards(card):

	# if not mesa-card: return

	"""
	Let card enumerate its available connectors. For a 5I25 they
	might be "P3" (0) and "P2" (1), both of type P25.

	Fetch the daughter board types that fit the connectors.

	Let the user select connector and card type:
	"""
	conn = 1
	card.add_daughter(M7I77(card.no_daughters()), conn)
	# I'm not clear on how the HAL pin names are assigned...
	#conn = 0
	#card.add_daughter(M7I76(card.no_daughters()), conn)


def get_axes(machine):

	"""
	Enumerate available outputs, feedback devices etc. Let user
	choose.
	"""
	axisno = 0
	axis = Axis(axisno)
	axis.set_output(HM2AnalogOut("hm2_5i25.0.7i77.0.1", axisno, 0))
	axis.set_feedback(HM2Encoder("hm2_5i25.0.encoder.00", axisno))
	machine.axes.append(axis)

	axisno = 1
	axis = Axis(axisno)
	# Let's use analogout2 for this axis:
	axis.set_output(HM2AnalogOut("hm2_5i25.0.7i77.0.1", axisno, 2))
	axis.set_feedback(HM2Encoder("hm2_5i25.0.encoder.01", axisno))
	machine.axes.append(axis)

	#"""
	axisno = 2
	axis = Axis(axisno)
	# ... and analogout1 for this one:
	axis.set_output(HM2AnalogOut("hm2_5i25.0.7i77.0.1", axisno, 1))
	axis.set_feedback(HM2Encoder("hm2_5i25.0.encoder.02", axisno))
	machine.axes.append(axis)
	#"""


machine = Machine(get_machine_name())
#get_installed_HW(machine)
#for card in machine.cards:
#	get_daughtercards(card)
get_axes(machine)

generate_hal(machine)

